#!/usr/bin/perl
$Data = "/pfad/zum/verzeichnis/htdocs/regpass";
    #Hier den Pfad zu dem Verzeichnis notieren welches die Registrierungsdaten
    #enthlt. Dieses Verzeichnis muss CHMOD 777 besitzen
$ProtectedDir = "/pfad/zum/verzeichnis/htdocs/download";
    #Der absolute Pfad zum geschtzten Verzeichnis - Verzeichnis muss CHMOD 777 haben
$ProtectedURL = "http://www.domain.de/download/";
    #Hier die URL des geschtzten Verzeichnisses eintragen CHMOD 777
$MailProgram = "/usr/sbin/sendmail";
    #Der Pfad zu Sendmail
$AdminEmail = "mailname\@domain.de";
    #Die Administrator Mailadresse
$SiteName = "Domain.de Registration";
    #Ds ist der Name der geschtzten Seite/Registrierungsseite
$FONT = "<FONT SIZE=\"2\" FACE=\"verdana,helvetica,arial\">";
    #Hier die gewnschte Schriftart angeben 
#######################################################################

&Parse;
&Date;

$ScriptURL = "http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}";

if($ENV{'QUERY_STRING'} =~ /^admin/) {
    if(&CheckAdminPass) {
	&Admin;
    } else {
	&AdminLogin;
    }
}
elsif($ENV{'QUERY_STRING'} =~ /^activate/) {&Activate}
elsif($ENV{'QUERY_STRING'} =~ /^findpass/) {&FindPass}
else {&Register}

sub Register {
    if($FORM{'action'} eq 'register') {
        %REG_FIELDS =  ('regfname', 'Vorname',
			'reglname', 'Nachname',
			'regaddress', 'Address',
			'regcity', 'City',
			'regstate', 'State',
			'regzip', 'Postleitzahl',
			'regcountry', 'Bundesland',
			'regemail', 'E-Mail',
			'reguser', 'UserID',
			'regpass', 'Passwort',
			'regcompare', 'Passwort Besttigung');

	#Get keys for registration fields, don't use keys() command
	#as we want the keys in a specific order.
	@RegKeys = ('regfname', 'reglname', 'regaddress', 'regcity',
			'regstate', 'regzip', 'regcountry', 'regemail',
			'reguser', 'regpass', 'regcompare');
	foreach $key (@RegKeys) {
	    if(!$FORM{$key}) {
		push(@MISSING_FIELDS, $key);
	    }
	}

	if(&check_email($FORM{'regemail'})) {
	    #Email is properly formated.
	    if($FORM{'regpass'} eq $FORM{'regcompare'}) {
		#Both passwords match
	    	if(@MISSING_FIELDS) {
	    	    # If the user forgot some fields or entered an e-mail address
	    	    # not formatted correctly, then stop the registration process
	    	    # and report this.
	            if($#MISSING_FIELDS > 10) {
		        # The user has submitted a blank form so print out the
		        # registration page again.
		        $FORM{'action'} = '';
		        &Register;
	            } else {
	    	        # The User has submitted an incomplete form so report
		        # missing fields only.

	    	        &PrintHead('Formular nicht vollstndig', '1');
	      	        print "<CENTER>Um die Registrierung fortfhren zu knnen<BR>\n";
	    	        print "mssen alle Felder korrekt ausgefllt sein.<BR>\n";
	    	        print "Bitte berichtigen und nochmals versuchen.<P>\n";
	    	        print "<FORM ACTION=\"$ScriptURL?register\" METHOD=\"POST\">\n";
	    	        @all_submitted_keys = keys(%FORM);
	    	        for($ask_a = 0; $ask_a <= $#all_submitted_keys; $ask_a++) {
		            if($FORM{$all_submitted_keys[$ask_a]}) {
		                print "<INPUT TYPE=\"HIDDEN\" NAME=\"$all_submitted_keys[$ask_a]\" VALUE=\"$FORM{$all_submitted_keys[$ask_a]}\">\n";
		            }
	    	        }
	    	        print "<TABLE BORDER=0 CELLPADDING=5>\n";
	      	        print "Diese Felder sind vergessen worden:<BR><OL>\n";
	 	        $show_miss_num = 0;
	    	        for($mf_a = 0; $mf_a <= $#RegKeys; $mf_a++) {
		            if(!$FORM{$RegKeys[$mf_a]}) {
			        $show_miss_num ++;
		                print "<TR><TD ALIGN=\"RIGHT\">$FONT$show_miss_num</FONT></TD><TD ALIGN=\"RIGHT\">$FONT$REG_FIELDS{$RegKeys[$mf_a]}:</FONT></TD><TD><INPUT TYPE=\"TEXT\" NAME=\"$RegKeys[$mf_a]\" SIZE=40></TD></TR>\n";
		            }
	    	        }
	    	        print "</OL></FONT></TD></TR></TABLE><P>\n";
	    	        print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Registration neu senden Form\"></FORM></CENTER><P>\n";
	    	        &PrintFoot;
	            }
	        } else {
	            # There were no missing fields and the e-mail address was
	            # formatted correctly so proceed with the registration.
	            $FORM{'reguser'} =~ s/\W//g;
	            $FORM{'reguser'} =~ s/ +/_/g;
	            $FORM{'regpass'} =~ s/\W//g;
	            $FORM{'regpass'} =~ s/ +/_/g;
	            $FORM{'regcompare'} =~ s/\W//g;
	            $FORM{'regcompare'} =~ s/ +/_/g;

	            # Check to make sure the first character of the submitted
	            # UserID is a letter and not a number. If it is a number,
	            # then take the first letter in the UserID or the first
	            # letter in the Users last name and append it at the front
	            # of the submitted UserID.

	            if($FORM{'reguser'} =~ /^\d/) {
		        if($FORM{'reguser'} =~ /^.+[^\w](\w[^\d])/) {
		            $first_letter = $1;
		            $FORM{'reguser'} = "$first_letter$FORM{'reguser'}";
	    	        } else {
		            $FORM{'reglname'} =~ /^.+[^\w](\w[^\d])/;
		            $first_letter = $1;
		            $FORM{'reguser'} = "$first_letter$FORM{'reguser'}";
		        }
	            }
	            # Check to make sure the UserID is between 4 and 10 characters.
	            $FORM{'reguser'} = format_length($FORM{'reguser'}, 4, 10);
	            $FORM{'regpass'} = format_length($FORM{'regpass'}, 4, 10);

		    #Check to make sure this username does not exist.
		    if(-e "$Data/users/$FORM{'reguser'}.file") {
			$user_exists_error = 1;
		    } else {
			#Check all the temporary files to make sure that
			#the user name doesn't clash there as well.
    			opendir(READ, "$Data/temp");
    			@all_temps = readdir(READ);
    			closedir(READ);
    			foreach $temp (@all_temps) {
			    @temp_line = ();
			    if($temp =~ /^\d+\.file$/) {
				@temp_line = getfile("$Data/temp/$temp");
				if($temp_line[0] =~ /^$FORM{'reguser'}\|\|/) {
				    $user_exists_error = 1;
				    last;
				}
			    }
    			}
			#Check the email address against all the email
			#addresses in the find_pass.list file.
			@findpass = getfile("$Data/find_pass.list");
			if(!$findpass[0]) {
			    @findpass = restore("$Data/find_pass.list");
			}
			for($ce_a = 0; $ce_a <= $#findpass; $ce_a++) {
			    if($findpass[$ce_a] =~ /^$FORM{'regemail'}\|\|/) {
				$user_exists_error_email = 1;
				last;
			    }
	    		}
		    }

		    # Check to make sure the users e-mail address is not on
		    # the banned users list.
		    if($user_exists_error || $user_exists_error_email) {
			if($user_exists_error) {
	    		    &PrintHead('User Name existiert schon', 1);
	    	 	    print "<FORM ACTION=\"$ScriptURL\" METHOD=\"POST\">\n";
	    		    @all_keys = keys(%FORM);
	    		    foreach $key (@all_keys) {
			    	unless($key eq 'reguser') {
		    		    print "<INPUT TYPE=\"HIDDEN\" NAME=\"$key\" VALUE=\"$FORM{$key}\">\n";
		    	    	}
	    		    }
  	    		    print "<BLOCKQUOTE><B>Der gewhlte Username exsistiert schon. Bitte anderen whlen und neu absenden.</B><P>";
	    	   	    print "<CENTER><INPUT TYPE=\"text\" NAME=\"reguser\" VALUE=\"$FORM{'reguser'}\"><INPUT TYPE=\"SUBMIT\" VALUE=\"Neu Senden\"></CENTER></FORM><P>\n";
			} else {
			    &PrintHead('E-Mail Addresse existiert schon', 1);
	    		    print "<FORM ACTION=\"$ScriptURL\" METHOD=\"POST\">\n";
	    		    @all_keys = keys(%FORM);
	    		    foreach $key (@all_keys) {
			        unless($key eq 'regemail') {
		    		    print "<INPUT TYPE=\"HIDDEN\" NAME=\"$key\" VALUE=\"$FORM{$key}\">\n";
		    	        }
	    	 	    }
  	    		    print "<BLOCKQUOTE><B>Die E-Mail Adresse existiert schon. Bitte berichtigen oder andere eintragen. Dann neu absenden.</B><P>";
	    		    print "<CENTER><INPUT TYPE=\"text\" NAME=\"regemail\" VALUE=\"$FORM{'regemail'}\"><INPUT TYPE=\"SUBMIT\" VALUE=\"Neu Senden\"></CENTER></FORM><P>\n";
			}
	    		&PrintFoot;
		    } else {
	      	        if(&CheckBanned($FORM{'regemail'})) {
		            # Check to make sure they submitted a password and
		            # that it is identical to the comparison entry.
	
			    # Concantenate the full name from a first name and last name.
		      	    $Name = $FORM{'regfname'} . " " . $FORM{'reglname'};
	
			    # Create the data text line to store the User Profile.
		    	    $NewLine = join('||',   $FORM{'reguser'},  $FORM{'regpass'},
					$Name, $FORM{'regaddress'},
					$FORM{'regcity'},  $FORM{'regstate'},
					$FORM{'regzip'}, $FORM{'regemail'},  
					$FORM{'regcountry'});


			    # Add the user data to the activation file to await activation
		  	    # by the user. First assign an activation code.
	    	    	    if(open(ACTIV, ">$Data/temp/$PID_DATE.file")) {
			        flock(ACTIV, '2');
		    	        print ACTIV "$NewLine\n";
		    	        close(ACTIV);
			        # Registration is now complete, all other
			        # registration functions are now accessed
			        # via the Activation sub routine. Now email
			        # the account activation information and
			        # print out confirmation and instructions
			        # to the user.

		    	        if(open (MAIL, "|$MailProgram -t")) {
    	    	    		    print MAIL "To: $FORM{'regemail'}\n";
    	    	    		    print MAIL "From: $AdminEmail\n";
    	    	    		    print MAIL "Subject: $SiteName Account Aktivierung\n\n";
				    print MAIL "Danke fr die Registrierung!\n\n";

				    print MAIL "Zum aktivieren des Accounts klicke den folgenden Link,\n";
				    print MAIL "oder kopiere diese in die Adresszeile des Browsers.\n";
				    print MAIL "Dadurch wird der Account aktiviert, wird der Account nicht\n";
				    print MAIL "wie beschrieben aktiviert kann kein Zugriff erfolgen:\n\n";
				    print MAIL "$ScriptURL?activate=$PID_DATE\n\n";

			 	    print MAIL "Nach der Aktivierung des Accounts wird\n";
				    print MAIL "eine E-Mail mit den Zugangsdaten abgesendet.\n";
				    print MAIL "Diese enthlt Username und Passwort Bitte gut aufheben!\n\n";

				    print MAIL "Copyright, $THISYEAR, $SiteName\n\n";
				    close(MAIL);

		    		    &PrintHead('Registration erfolgreich', '1');
		    		    print "<P><CENTER>Registration erfolgreich!<P>\n";
		    		    print "Die Registrierung war erfolgreich.<BR>\n";
				    print "Es wurde eine E-Mail an die angegebene Adresse versandt.<BR>\n";
				    print "Darin enthalten sind die Anweisungen zur Aktivierung des Accounts..<P>\n";
				    print "Um den Account zu aktivieren mssen die anweisungen<BR>\n";
				    print "in der E-Mail eingehalten werden.<BR>\n";
				    print "Es kann kein Zugriff auf den Account erfolgen<BR>\n";
			 	    print "wenn dieser nicht aktiviert wurde.<P>\n";
				    print "</CENTER><P>\n";
		    		    &PrintFoot;
			        } else {
			 	    # The program failed to e-mail the activation code. Therefore,
				    # tell the User to notify the admin, Log and report.
			  	    $Problem = "Problem beim E-Mailversand! Das Programm kann die E-Mail mit dem Aktivierungsdaten nicht versenden. Bitte Mail senden an <A HREF=\"mailto:$AdminEmail?subject=Fehlerhafte Accountaktivierung ($PID_DATE)\">Administrator, das dieser den Account einrichtet.";
				    &Error($Problem);
			        }
			    } else {
			        #The program failed to store the user data in an activation file. Log and Error.
			        $Problem = "Problem beim speichern der Accountaktivierung. Bitte Mail senden an <A HREF=\"mailto:$AdminEmail?subject=Aktivierungscode nicht gespeichert\">Administrator</A>.";
			        &Error($Problem);
			    }
		        } else {
			    # Users E-Mail address is on the banned list.
			    $Problem = "Ihr Name ist in der Liste der nichtzugelassenen User. Um wieder aufgenommen werden zu knnen mssen Sie mit dem <A HREF=\"mailto:$AdminEmail\">Administrator</A> Kontakt aufnehmen.";
			    &Error($Problem);
		        }
		    }#close if-exists_error-else
		}#close if-missingfields-else
	    } else {
		&PrintHead('Passwort verschieden', 1);
		print "<FORM ACTION=\"$ScriptURL\" METHOD=\"POST\">\n";
		@all_keys = keys(%FORM);
		foreach $key (@all_keys) {
		    unless(($key eq 'regpass') || ($key eq 'regcompare')) {
			print "<INPUT TYPE=\"HIDDEN\" NAME=\"$key\" VALUE=\"$FORM{$key}\">\n";
		    }
		}
		print "<BLOCKQUOTE><B>Die zwei eingegebenen Passwrter sind nicht gleich. Bitte neu eintragen und absenden.</B><P>";
		print "<TABLE BORDER=0 WIDTH=350>\n";
		print "<TR><TD>$FONT<FONT COLOR=\"MAROON\">Passwort muss 4 - 10 Zeichen haben. Buchstaben und Zahlen sind erlaubt. Das erste Zeichen muss ein Buchstabe sein.</FONT><P>\n";
		print "<INPUT TYPE=\"password\" NAME=\"regpass\"> Passwort<BR>\n";
		print "<INPUT TYPE=\"password\" NAME=\"regcompare\"> Passwort Besttigung \n";
		print "</FONT></TD></TR></TABLE><P>\n";
		print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Neu Senden\"></FORM><P>\n";
		&PrintFoot;
	    }
	} else {
	    &PrintHead('E-Mail Adressen Error', 1);
	    print "<FORM ACTION=\"$ScriptURL\" METHOD=\"POST\">\n";
	    @all_keys = keys(%FORM);
	    foreach $key (@all_keys) {
		unless($key eq 'regemail') {
		    print "<INPUT TYPE=\"HIDDEN\" NAME=\"$key\" VALUE=\"$FORM{$key}\">\n";
		}
	    }
  	    print "<BLOCKQUOTE><B>Die E-Mail Adresse wurde im falschen Format eingegeben. Bitte korrigieren und neu senden.</B><P>";
	    print "<INPUT TYPE=\"text\" NAME=\"regemail\" VALUE=\"$FORM{'regemail'}\"><INPUT TYPE=\"SUBMIT\" VALUE=\"Neu Senden\"></FORM><P>\n";
	    &PrintFoot;
	}
    } else {
	&PrintHead("Registrations Seite", 1);
	print "<CENTER>Danke fr die Registrierung!</CENTER><P>\n";
	print "<BLOCKQUOTE>Die Registrierung erlaubt den zugriff\n";
	print "auf ein Passwortgeschtztes Verzeichnis mit Informationen und Daten.\n";
	print "</BLOCKQUOTE><P>\n";

	print "<FORM ACTION=\"$ScriptURL\" METHOD=\"POST\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"register\">\n";
	print "<CENTER><TABLE BORDER=0 WIDTH=400><TR><TD ALIGN=\"CENTER\">\n";
	print "<TABLE BORDER=0 CELLPADDING=5>\n";

	print "<TR><TD><HR SIZE=2 NOSHADE></TD></TR>\n";
	print "<TR><TD ALIGN=\"CENTER\">\n";
	print "<TABLE BORDER=0 WIDTH=350>\n";
	print "<TR><TD COLSPAN=2 ALIGN=\"CENTER\">$FONT<B>Alle Felder ausfllen!</B></FONT><P></TD></TR>\n";
  
	print "<TR><TD><INPUT TYPE=\"TEXT\" NAME=\"regfname\">$FONT Vorname</FONT></TD></TR>\n";
	print "<TR><TD><INPUT TYPE=\"TEXT\" NAME=\"reglname\">$FONT Nachname</FONT></TD></TR>\n";
	print "<TR><TD><INPUT TYPE=\"TEXT\" NAME=\"regaddress\">$FONT Addresse</FONT></TD></TR>\n";
	print "<TR><TD><INPUT TYPE=\"TEXT\" NAME=\"regcity\">$FONT Stadt</FONT></TD></TR>\n";
	print "<TR><TD><INPUT TYPE=\"TEXT\" NAME=\"regstate\">$FONT Land</FONT></TD></TR>\n";
	print "<TR><TD><INPUT TYPE=\"TEXT\" NAME=\"regzip\">$FONT Postleitzahl</FONT></TD></TR>\n";
	print "<TR><TD><INPUT TYPE=\"TEXT\" NAME=\"regcountry\">$FONT Bundesland</FONT></TD></TR>\n";

	print "<TR><TD><BR>$FONT E-Mail Adresse<BR></FONT><INPUT TYPE=\"TEXT\" NAME=\"regemail\"></TD></TR>\n";
	print "</TABLE><HR SIZE=3 NOSHADE>\n";

	print "<TABLE BORDER=0 WIDTH=350>\n";
	print "<TR><TD><BR>$FONT<B>Whle Username und Passwort</B><BR><FONT COLOR=\"MAROON\">*4 bis 10 Zeichen. Buchstaben und Zahlen sind erlaubt. Das erste Zeichen muss ein Buchstabe sein.</FONT><P>\n";
	print "<B>Whle User Name</B>\n";
	print "<BR><INPUT TYPE=\"TEXT\" NAME=\"reguser\">\n";
	print "<P><B>Whle Passwort</B><BR>\n";
	print "<INPUT TYPE=\"password\" NAME=\"regpass\"> Passwort<BR>\n";
	print "<INPUT TYPE=\"password\" NAME=\"regcompare\"> Passwort Besttigung\n";
	print "</TD></TR></TABLE><P>\n";

	print "$FONT Zur Beachtung! Es ist strengstens untersagt Usernamen und oder Passwort unbefugten zu berlassen. Dieses fhrt zum sperren des Accounts.<P></FONT>\n";
	print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Registrieren\">\n";
	print "<INPUT TYPE=\"RESET\" NAME=\"Abbrechen\"></TD></TR>\n";
	print "</TABLE></TD></TR></TABLE><HR SIZE=\"2\" NOSHADE></CENTER></FORM><P>\n";
	&PrintFoot;
    }
}

sub Activate {
    if($ENV{'QUERY_STRING'} =~ /^activate\=(\d+)$/) {
	$TEMPID = $1;
	if(-e "$Data/temp/$TEMPID.file") {
	    @newuser = getfile("$Data/temp/$TEMPID.file");
	    @item = split(/\|\|/, $newuser[0]);
	    rename("$Data/temp/$TEMPID.file", "$Data/users/$item[0].file");
	    $salt = substr($item[1], 0, 2);

	    if(-e "$ProtectedDir/.htaccess") {
		$htaccess_exists = 1;
	    } else {
	        if(open(NEW, ">$ProtectedDir/.htaccess")) {
		    print NEW "<LIMIT GET POST>\n";
		    print NEW "Require valid-user\n";
		    print NEW "</LIMIT>\n\n";

		    print NEW "AuthType     Basic\n";
		    print NEW "AuthName     \'Protected Directory'\n";
		    print NEW "AuthUserFile $ProtectedDir/.htpasswd\n";
		    close(NEW);
		    $htaccess_exists = 1;
		} else {
		    $htaccess_exists = 0;
		}
	    }
	    if($htaccess_exists) {
    	    	my (@salt_chars) = ('A' .. 'Z', 0 .. 9, 'a' .. 'z', '.', '/');
            	my ($salt) = join '', @salt_chars[rand 64, rand 64];
    	    	my ($encrypted) = crypt($item[1], $salt);
	    	$new_user = "$item[0]:$encrypted";
		fileadd("$ProtectedDir/.htpasswd", $new_user);
		backup("$ProtectedDir/.htpasswd");
		&FindPassAdd($item[7], $item[0], $item[1]);
		if(open(MAIL, "|$MailProgram -t")) {
		    print MAIL "To: $item[7] ($item[2])\n";
		    print MAIL "From: $AdminEmail\n";
		    print MAIL "Subject: Account aktiviert!\n\n";

		    print MAIL "Danke fr die Aktivierung des Accounts bei\n";
		    print MAIL "$SiteName\n\n";
		    print MAIL "User Name lautet: $item[0]\n\n";
		    print MAIL "Passwort lautet: $item[1]\n\n";
		    print MAIL "Diese Informationen gut aufheben,\n";
		    print MAIL "und keiner unbefugten Person zugriff gestatten.\n\n";
		    print MAIL "Danke \n$SiteName\n\n";
		    close(MAIL);
		    $confirmation_email_sent = 1;
		}
		&PrintHead('Aktivierung erfolgreich', 1);
		print "<BLOCKQUOTE>Der Username und das Passwort wurden in der Datenbank gespeichert.. Hier klicken fr zugriff zum <A HREF=\"$ProtectedURL\">Mitgliederbereich</A><P>\n";
		unless($confirmation_email_sent) {
		    print "Aufgrund eines Fehler kann der User Name und Passwort nicht per Mail versandt werden. Bitte die Daten deshalb hier notieren:<P>\n";
		    print "<CENTER><B>User Name:</B> $item[0]<P>\n";
		    print "<B>Passwort:</B> $item[1]\n";
		}
		print "</BLOCKQUOTE><P>\n";
		&PrintFoot;
	    } else {
		$Problem = "Ein Fehler der .htacces Datei ist aufgetreten. Der Administrator wurde benachrichtigt und wird das Problem in krze beheben.";
		if(open(MAIL, "|$MailProgram -t")) {
	    	    print MAIL "To: $AdminEmail\n";
    	    	    print MAIL "From: $AdminEmail\n";
    	    	    print MAIL "Subject: Kritischer Fehler\n\n";
		    print MAIL "Es kann sein das die Datei .htacess nicht mehr\n";
		    print MAIL "am $ENV{'SERVER_NAME'} vorhanden ist, oder defekt..\n\n";
		    print MAIL "Dadurch ist die Seite frei zugnglich! Bitte die Datei\n";
		    print MAIL "sofort neu installieren!!!\n\n\n";
		    close(MAIL);
		}
	 	&Error($Problem);
	    }
	} else {
	    $Problem = "Die Aktivierungsdatei ist nicht mehr vorhanden, oder es wurde die falsche URL im Browser eingetragen. Auch muss der Account innerhalb 48 Stunden aktiviert sein. Bitte deshalb <A HREF=\"$ScriptURL\">neu registrieren</A>";
	    &Error($Problem);
	}
    } else {
	$Problem = "Das Programm kann nicht mit ungltigen Daten benutzt werden.";
	&Error($Problem);
    }

    #Now scrub the activation directory
    opendir(READ, "<$Data/temp");
    @all_temps = readdir(READ);
    closedir(READ);
    foreach $temp (@all_temps) {
	if($temp =~ /^\d+\.file$/) {
	    $age = fileage('day', "$Data/temp/$temp", 1);
	    if($age >= 2) {
		unlink("$Data/temp/$temp");
	    }
	}
    }
}

sub Admin {
    if(($FORM{'action'} eq 'delete_user') || ($FORM{'action'} eq 'ban_user')) {
	@user = getfile("$Data/users/$FORM{'userid'}.file");
	@item = split(/\|\|/, $user[0]);
	if(open(PASS, "<$ProtectedDir/.htpasswd")) {
	    flock(PASS, '1');
	    @pass_list = <PASS>;
	    close(PASS);
	    chomp(@pass_list);
	    if(open(PASS2, ">$ProtectedDir/.htpasswd")) {
		flock(PASS2, '3');
		for($a = 0; $a <= $#pass_list; $a++) {
		    unless($pass_list[$a] =~ /^$FORM{'userid'}\:.+$/) {
			print PASS2 "$pass_list[$a]\n";
		    }
		}
		close(PASS2);
	    	unlink("$Data/users/$FORM{'userid'}.file");
		if($FORM{'action'} eq 'ban_user') {
	    	    fileadd("$Data/banned.list", $item[7]);
	    	    backup("$Data/banned.list");
		}
		&FindPassRemove($item[7]);
		$FORM{'action'} = '';
		&Admin;
	    } else {
		$Problem = "Das Programm kann den User \"$FORM{'userid'}\" nicht entfernen. Bitte manuell entfernen.";
		&Error($Problem);
	    }
	} else {
	    $Problem = "Das Programm findet die .htpasswd Datei nicht.";
	    &Error($Problem);
	}
    }
    elsif($FORM{'action'} eq 'mail_user') {
	@user = getfile("$Data/users/$FORM{'userid'}.file");
	@item = split(/\|\|/, $user[0]);
	#print mail form
	if($FORM{'mailto'}) {
	    if($FORM{'email_comments'}) {
		if(!$FORM{'subject'}) {
		    $FORM{'subject'} = "$SiteName Contact";
		}
		if(open(MAIL, ">|$MailProgram -t")) {
		    print MAIL "To: $item[7]\n";
		    print MAIL "From: $AdminEmail\n";
		    print MAIL "Subject: $FORM{'subject'}\n\n";
		    print MAIL "$FORM{'email_comments'}\n\n";
		    print MAIL "Copyright $THISYEAR, $SiteName\n\n";
		    close(MAIL);
		    &PrintHead('E-Mail senden', 1);
		    print "<BR><BR><BR><BR><BR><BR><BR><BR>\n";
		    &PrintFoot;
		} else {
		    $Problem = "Das Programm kann die E-Mail nicht versenden. Bitte nochmals versuchen.";
		    &Error($Problem);
		}
	    } else {
		$Problem = "Es wurde kein Text in die E-Mail eingetragen.";
		&Error($Problem);
	    }
	} else {
	    &PrintHead('E-Mail Kontakt Formular', 1);
	    print "<FORM ACTION=\"$ScriptURL?admin\" METHOD=\"POST\">\n";
	    print "<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"mail_user\">\n";
	    print "<INPUT TYPE=\"HIDDEN\" NAME=\"user\" VALUE=\"$FORM{'user'}\">\n";
	    print "<INPUT TYPE=\"HIDDEN\" NAME=\"pass\" VALUE=\"$FORM{'pass'}\">\n";
	    print "<P><CENTER><TABLE BORDER=0>\n";
	    print "<TR><TD ALIGN=\"RIGHT\" VALIGN=\"TOP\">$FONT<B>To:</B></FONT></TD>\n";
	    print "<TD>$FONT$item[2]<BR>$item[7]</FONT></TD></TR>\n";
	    print "<TR><TD ALIGN=\"RIGHT\" VALIGN=\"TOP\">$FONT<B>From:</B></FONT></TD>\n";
	    print "<TD>$FONT$AdminEmail</FONT></TD></TR>\n";
	    print "<TR><TD ALIGN=\"RIGHT\" VALIGN=\"TOP\">$FONT<B>Subject:</B></FONT></TD>\n";
	    print "<TD><INPUT TYPE=\"TEXT\" NAME=\"subject\" SIZE=40></TD></TR>\n";
	    print "</TABLE><P><B>Kommentar:</B><BR>\n";
	    print "<TEXTAREA NAME=\"email_comments\" COLS=40 ROWS=10></TEXTAREA><P>\n";
	    print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Sende E-Mail\"></FORM><P></CENTER>\n";
	    &PrintFoot;
	}
    } else {
	&PrintHead('Admin Panel', 1);
	print "<FORM ACTION=\"$ScriptURL?admin\" METHOD=\"POST\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"user\" VALUE=\"$FORM{'user'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"pass\" VALUE=\"$FORM{'pass'}\">\n";
	print "<CENTER>\n";
	if($FORM{'action'} eq 'view_user') {
	    @user = getfile("$Data/users/$FORM{'userid'}.file");
	    @item = split(/\|\|/, $user[0]);
	    print "<TABLE BORDER=0>\n";
	    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>Name:</B></FONT></TD><TD>$FONT$item[2]</FONT></TD></TR>\n";
	    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>UserID:</B></FONT></TD><TD>$FONT$item[0]</FONT></TD></TR>\n";
	    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>Passwort:</B></FONT></TD><TD>$FONT$item[1]</FONT></TD></TR>\n";
	    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>E-Mail:</B></FONT></TD><TD>$FONT$item[7]</FONT></TD></TR>\n";
	    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>Addresse:</B></FONT></TD><TD>$FONT$item[3]</FONT></TD></TR>\n";
	    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>Stadt:</B></FONT></TD><TD>$FONT$item[4]</FONT></TD></TR>\n";
	    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>Land:</B></FONT></TD><TD>$FONT$item[5]</FONT></TD></TR>\n";
	    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>ZIP:</B></FONT></TD><TD>$FONT$item[6]</FONT></TD></TR>\n";
	    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>Bundesland:</B></FONT></TD><TD>$FONT$item[8]</FONT></TD></TR>\n";
	    print "</TABLE><P>\n";
	}
	print "<TABLE BORDER=6><TR><TD ALIGN=\"CENTER\"><TABLE BORDER=0>\n";
	print "<TR><TD COLSPAN=2><CENTER>$FONT<B>Whle eine User<BR>und<BR>eine Admin Option.</B></FONT><P>\n";
	print "<SELECT NAME=\"userid\" SIZE=1>\n";
	opendir(READ, "$Data/users");
	@all_users = readdir(READ);
	closedir(READ);
	@users = grep{/^.+\.file$/}@all_users;
	@users = sort(@users);
	for($a = 0; $a <= $#users; $a++) {
	    if($users[$a] =~ /\.file$/) {
	        ($userid, undef) = split(/\./, $users[$a]);
	        print "<OPTION VALUE=\"$userid\">$userid\n";
	    }
	}
	print "</SELECT></CENTER></TD></TR>\n";
	print "<TR><TD VALIGN=\"TOP\" ALIGN=\"RIGHT\" WIDTH=50%><INPUT TYPE=\"RADIO\" NAME=\"action\" VALUE=\"view_user\" CHECKED></TD><TD>$FONT<B>User Profile</B></FONT></TD></TR>\n";
	print "<TR><TD COLSPAN=2><HR></TD></TR>\n";
	print "<TR><TD VALIGN=\"TOP\" ALIGN=\"RIGHT\" WIDTH=50%><INPUT TYPE=\"RADIO\" NAME=\"action\" VALUE=\"delete_user\"></TD><TD>$FONT<B>Entferne User</B></FONT></TD></TR>\n";
	print "<TR><TD VALIGN=\"TOP\" ALIGN=\"RIGHT\" WIDTH=50%><INPUT TYPE=\"RADIO\" NAME=\"action\" VALUE=\"ban_user\"></TD><TD>$FONT<B>Entferne/sperre User</B></FONT></TD></TR>\n";
	print "<TR><TD ALIGN=\"CENTER\" COLSPAN=2><INPUT TYPE=\"SUBMIT\" VALUE=\"Ausfhren\"></TD></TR>\n";
	print "</TABLE></TD></TR></TABLE></CENTER></FORM><P>\n";

	&PrintFoot;
    }
}

sub CheckAdminPass {
    if($FORM{'user'} && $FORM{'pass'}) {
	$salt_u = substr($FORM{'user'}, 0, 2);
	$salt_p = substr($FORM{'pass'}, 0, 2);
	$cuser = crypt($FORM{'user'}, $salt_u);
	$cpass = crypt($FORM{'pass'}, $salt_p);
  	@pass_list = getfile("$Data/ownerpass.file");
	($checkuser, $checkpass) = split(/\t/, $pass_list[0]);
	if(($checkuser eq $cuser) && ($checkpass eq $cpass)) {
	    return(1);
	} else {
	    return(0);
	}
    } else {
	return(0);
    }
}

sub AdminLogin {
    &PrintHead('Admin Login Page', 1);
    print "<FORM ACTION=\"$ScriptURL?admin\" METHOD=\"POST\">\n";
    print "<P><CENTER>\n";
    print "<TABLE BORDER=3><TR><TD ALIGN=\"CENTER\"><TABLE BORDER=0>\n";
    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>User ID:</B></FONT></TD><TD><INPUT TYPE=\"PASSWORD\" NAME=\"user\" SIZE=10></TD></TR>\n";
    print "<TR><TD ALIGN=\"RIGHT\">$FONT<B>Passwort:</B></FONT></TD><TD><INPUT TYPE=\"PASSWORD\" NAME=\"pass\" SIZE=10></TD></TR>\n";
    print "<TR><TD ALIGN=\"CENTER\" COLSPAN=2><INPUT TYPE=\"SUBMIT\" VALUE=\"Enter!\"></TD></TR>\n";
    print "</TABLE></TD></TR></TABLE></FORM><P>\n";
    print "</CENTER><BR><BR><BR><BR><BR><BR>\n";
    &PrintFoot;
}

####################

sub CheckBanned {
    $ban_check = $_[0];
    @banned = getfile("$Data/banned.list");
    if(!$banned[0]) {
	@banned = restore("$Data/banned.list");
    }
    if(@banned) {
	foreach $ban (@banned) {
	    if($ban eq $ban_check) {
		$user_is_banned = 1;
		last;
	    }
	}
	if($user_is_banned) {
	    return(0);
	} else {
	    return(1);
	}
    } else {
	return(1);
    }
}

sub format_length {
    my($fl_var) = $_[0];
    my($fl_min) = $_[1];
    my($fl_max) = $_[2];
    my($fl_length) = length($fl_var);
    if($fl_length > $fl_max) {
    	$fl_return = substr($fl_var, 0, $fl_max);
 	return($fl_return);
    }
    elsif($fl_length < $fl_min) {
    	my($fl_redo) = $fl_var x 2;
   	$fl_return = format_length($fl_redo, $fl_min, $fl_max);
  	return($fl_return);
    } else {
   	$fl_return = $fl_var;
   	return($fl_return);
    }
}

sub PrintHead {
    $title = $_[0];
    $headline = $_[1];
    print "Content-type: text/html\n\n";

    print "<HEAD><TITLE>User Registration - $title</TITLE></HEAD>\n";
    print "<BODY TEXT=\"#330066\" LINK=\"#336666\" ALINK=\"#336666\" VLINK=\"#336666\" BGCOLOR=\"#FFFFE3\">$FONT\n";
    if($headline) {
	print "<H2 ALIGN=\"CENTER\">$title</H2><HR>\n";
    }
}

sub PrintFoot {
    print "$FONT<CENTER>\n";
    print "<HR WIDTH=65%><A HREF=\"mailto:$AdminEmail\">&copy $THISYEAR, $SiteName</A><BR>\n";
    print "Powered by <A HREF=\"http://www.inspire-net.de\" target=\"_top\">Inspire-net</A><P>\n";
    print "</FONT></BODY></HTML>\n";
}

sub Error {
    $cause = $_[0];
    &PrintHead('Error...', 1);
    print "<BLOCKQUOTE>Das Programm hat einen Fehler festgestellt welcher $cause.</BLOCKQUOTE><BR><BR><BR><BR><BR><BR>\n";
    &PrintFoot;
}

sub getfile {
    my($gf_path, @gf_contents);
    $gf_path = $_[0];
    if(open(GET, "<$gf_path")) {
	flock(GET, '2');
	@gf_contents = <GET>;
	close(GET);
	chomp(@gf_contents);
	return(@gf_contents);
    } else {
	return();
    }
    undef($gf_path, @gf_contents);
}

sub Parse {
    local($name, $value, $buffer, $pair, $hold, @pairs);

    if($ENV{'REQUEST_METHOD'} eq 'GET') {
        @pairs = split(/&/, $ENV{'QUERY_STRING'});
    } else {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
        @pairs = split(/&/, $buffer);
    }
    foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	unless($name eq 'email_comments') {
	    $value =~ s/\n//g;
	}

      #This section checks the value portion (user input) of
      #all name/value pairs.
	$value =~ s/<.+>?//g;		#Remove this tag to permit HTML tags
	$value =~ s/<!--(.|\n)*-->//g;
	$value =~ s/\s-\w.+//g;
	$value =~ s/system\(.+//g;
	$value =~ s/grep//g;
	$value =~ s/\srm\s//g;
	$value =~ s/\srf\s//g;
	$value =~ s/\.\.([\/\:]|$)//g;
	$value =~ s/< *((SCRIPT)|(APPLET)|(EMBED))[^>]+>//ig;

      #This section checks the value portion (from element name) of
      #all name/value pairs. This was included to prevent any nasty
      #surprises from those who would hijack you forms!
        $name =~ s/<.+>?//g;
	$name =~ s/<!--(.|\n)*-->//g;
	$name =~ s/^\s-\w.+//g;
	$name =~ s/system\(.+//g;
	$name =~ s/grep//g;
	$name =~ s/\srm\s//g;
	$name =~ s/\srf\s//g;
	$name =~ s/\.\.([\/\:]|$)//g;
	$name =~ s/< *((SCRIPT)|(APPLET)|(EMBED))[^>]+>//ig;

	$FORM{$name} = $value;
    }
}

sub fileage {
    my($type, $fl, $constant, %fa, @fa_keys, $fa_a, 
		$fa_found, $fa_temp1, $fa_temp2, $integer_off);
    $type    = $_[0];
    $fl      = $_[1];
    $integer_off = $_[2];
    if(-e "$fl") {
        $constant = (-C "$fl");
	%fa = (); $fa_found = 0;
	$fa{'sec'} = $constant * 86400;
	$fa{'min'} = $constant * 1440;
	$fa{'hr'}  = $constant * 24;
	$fa{'day'} = $constant;
	$fa{'wk'}  = $constant / 7;
	$fa{'yr'}  = $constant / 365;
        $fa_temp1 = $^T - int((-M "$fl") * 86400);
        $fa_temp2 = $^T - int((-C "$fl") * 86400);
	$fa{'mod'}  = localtime($fa_temp1);
    	$fa{'date'} = localtime($fa_temp2);
	if($type) {
            unless($type =~ /\D[^\.]/) {
		if($integer_off) {
	    	    $fa{'p'} = $constant / $type;
		} else {
		    $fa{'p'} = int($constant / $type);
		}
	    }
	}
	@fa_keys = keys(%fa);
        unless($integer_off) {
	    for($fa_a = 0; $fa_a <= $#fa_keys; $fa_a++) {
		unless($fa_keys[$fa_a] =~ /date|mod|p/) {
		    $fa{$fa_keys[$fa_a]} = int($fa{$fa_keys[$fa_a]});
		}
	    }
	    $fa_a = 0;
	}
	if($type) {
	    for($fa_a = 0; $fa_a <= $#fa_keys; $fa_a++) {
	        if($type eq $fa_keys[$fa_a]) {
		    return($fa{$fa_keys[$fa_a]});
		    $fa_found = 1;
		    last;
	        }
	    }
	    unless($fa_found) {
		return($fa{'p'});
	    }
	} else {
	    return($fa{'sec'}, $fa{'min'}, $fa{'hr'}, 
		$fa{'day'}, $fa{'wk'}, $fa{'yr'}, $fa{'date'}, $fa{'mod'});
   	}
        undef($type, $fl, $constant, %fa, @fa_keys, $fa_a, 
		$fa_found, $fa_temp1, $fa_temp2, $integer_off);
    } else {
	return();
    }
}

sub fileadd {
    my($fa_path, $fa_new, $fa_replace, $fa_open);
    $fa_path    = $_[0];
    $fa_new     = $_[1];
    $fa_replace = $_[2];
    $fa_open = 0;

    if($fa_replace) {
	if(open(NEW, ">$fa_path")) {
	    $fa_open = 1;
	}
    } else {
	if(open(NEW, ">>$fa_path")) {
	    $fa_open = 1;
	}
    }
    if($fa_open) {
	if($fa_new =~ /\n$/) {
	    chop($fa_new);
	}
	print NEW "$fa_new\n";
	close(NEW);
	return(1);
    } else {
	return(0);
    }
}

sub Date {
    my($second, $minute, $hour, $year, $weekday, $dayofyear, $isDST,
	$get_pid, $length_pid, $start_cut, $pid, $add_zero, $offset);
    $offset = time + ($time_offset * 3600);
    ($second, $minute, $hour, $DAYOFMONTH, $MONTH, $year, $weekday,
	$dayofyear, $isDST) = localtime($offset);
    $THISYEAR = $year + 1900;

    $MONTH++;
    if($MONTH < 10) {$MONTH = "0" . $MONTH}
    if($DAYOFMONTH < 10) {$DAYOFMONTH = "0" . $DAYOFMONTH}
    if($hour < 10) {$hour = "0" . $hour}
    if($minute < 10) {$minute = "0" . $minute}
    if($second < 10) {$second = "0" . $second}
    $DATE = "$THISYEAR/$MONTH/$DAYOFMONTH";
    $TIME = "$hour:$minute:$second";

    $get_pid = abs($$);
    $length_pid = length($get_pid);
    if($length_pid > 10) {
	$start_cut = $length_pid - 10;
	$pid = substr($get_pid, $start_cut, 10);
    }
    elsif($length_pid < 10) {
	$add_zero = 10 - $length_pid;
	$pid = "0" x $add_zero . $get_pid;
    } else {
	$pid = $get_pid;
    }
    $PID_DATE = "$THISYEAR$MONTH$DAYOFMONTH$pid";
}

sub check_email {
    my($fe_email) = $_[0];
    if($fe_email) {
        if(($fe_email =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) ||
	    ($fe_email !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,3}|[0-9]{1,3}\]?$/)) {
	    return(0);
        }
        else {return(1)}
    }
    else {
    	return(0);
    }
}

sub backup {
    my($bk_file) = $_[0];
    if(open(BKF, "<$bk_file")) {
	flock(BKF, '2');
	my(@backup) = <BKF>;
	close(BKF);
        if($bk_file eq "$ProtectedDir/.htpasswd") {
	    $bk_file = "$ProtectedDir/htpasswd.bak";
        } else {
	    $bk_file =~ s/^(.+)\.[^\.]\w+$/$1\.bak/;
	}
	if(open(BAKUP, ">$bk_file")) {
	    flock(BAKUP, '2');
	    print BAKUP @backup;
	    close(BAKUP);
	    return(1);
	} else {
	   return(0);
  	}
    } else {
	return(0);
    }
}

sub restore {
    my($rs_file) = $_[0];
    my($rs_file_bak) = $rs_file;
    if($rs_file_bak eq "$ProtectedDir/.htpasswd") {
	$rs_file_bak = "$ProtectedDir/htpasswd.bak";
    } else {
        $rs_file_bak =~ s/^(.+)\.[^\.]\w+$/$1\.bak/;
    }
    if(open(BKF, "<$rs_file_bak")) {
	flock(BKF, '2');
	my(@backup) = <BKF>;
	close(BKF);
	if(open(BAKUP, ">$rs_file")) {
	    flock(BAKUP, '2');
	    print BAKUP @backup;
	    close(BAKUP);
	    return(@backup);
	} else {
	   return(0);
  	}
    } else {
	return(0);
    }
}

sub FindPassAdd {
    $fpa_email = $_[0];
    $fpa_user  = $_[1];
    $fpa_pass  = $_[2];
    @findpass = getfile("$Data/find_pass.list");
    if(!$findpass[0]) {
	@findpass = restore("$Data/find_pass.list");
    }
    if(open(FIND, ">$Data/find_pass.list")) {
	$fpa_foundit = 0;
	for($fpa_a = 0; $fpa_a <= $#findpass; $fpa_a++) {
	    if($findpass[$fpa_a] =~ /^$fpa_email\|\|/) {
		print FIND "$fpa_email||$fpa_user||$fpa_pass\n";
		$fpa_foundit = 1;
	    } else {
		print FIND "$findpass[$fpa_a]\n";
	    }
	}
	unless($fpa_foundit) {
	    print FIND "$fpa_email||$fpa_user||$fpa_pass\n";
	}
	close(FIND);
	backup("$Data/find_pass.list");
 	return(1);
    } else {
	return(0);
    }
}

sub FindPassRemove {
    $fpr_email = $_[0];

    @findpass = getfile("$Data/find_pass.list");
    if(!$findpass[0]) {
	@findpass = restore("$Data/find_pass.list");
    }
    if(open(FIND, ">$Data/find_pass.list")) {
	for($fpr_a = 0; $fpr_a <= $#findpass; $fpr_a++) {
	    unless($findpass[$fpr_a] =~ /^$fpr_email\|\|/) {
		print FIND "$findpass[$fpr_a]\n";
	    }
	}
	close(FIND);
	backup("$Data/find_pass.list");
 	return(1);
    } else {
	return(0);
    }
}

sub FindPass {
    if($FORM{'find_email'}) {
        @findpass = getfile("$Data/find_pass.list");
        if(!$findpass[0]) {
	    @findpass = restore("$Data/find_pass.list");
        }
	for($fp_a = 0; $fp_a <= $#findpass; $fp_a++) {
	    if($findpass[$fp_a] =~ /^$FORM{'find_email'}\|\|/) {
		($fp_email, $fp_user, $fp_pass) = split(/\|\|/, $findpass[$fp_a]);
		last;
	    }
	}
	if($fp_email && $fp_user && $fp_pass) {
	    if(open(MAIL, "|$MailProgram -t")) {
		print MAIL "To: $fp_email\n";
		print MAIL "From: $AdminEmail ($SiteName)\n";
		print MAIL "Subject: Passwort Anforderung\n\n";
		print MAIL "Auf die Anforderung hin wurde das\n";
		print MAIL "Passwort und die User ID versandt.\n";
		print MAIL "Diese Informationen gut sichern,\n";
		print MAIL "und keinem Unbefugten zugnglich machen. \n";
		print MAIL "Dies sind die Daten:\n\n";
		print MAIL "USERID:  $fp_user\n\n";
		print MAIL "PASSWORD:    $fp_pass\n\n";
		print MAIL "Copyright, $THISYEAR,\n$SiteName\n\n";
		close(MAIL);
		&PrintHead('Info Retrieved!', 1);
		print "<CENTER><B>Die UserID und Passwort wurden gefunden.<BR>\n";
		print "Diese sind per Mail versandt worden und sollten sofort eintreffen.<BR><BR><BR><BR><BR></B></CENTER>\n";
		&PrintFoot;
	    } else {
		$Problem = "Das Programm kann nicht per E-Mail User ID und Passwort versenden obwohl die Daten gefunden wurden. Bitte nochmals versuchen.";
		&Error($Problem);
	    }
	} else {
	    &PrintHead('E-Mail Nicht gefunden', 1);
	    print "<CENTER><B>Die eingegebene E-Mailadresse wurde<BR>nicht gefunden. Bitte korrigieren und neu senden.<P>\n";
	    print "<FORM ACTION=\"$ScriptURL?findpass\" METHOD=\"POST\">\n";
	    print "E-Mail:<INPUT TYPE=\"TEXT\" NAME=\"find_email\" VALUE=\"$FORM{'find_email'}\" SIZE=30><INPUT TYPE=\"SUBMIT\" VALUE=\"Finde!\"></FORM><BR><BR><BR><BR></B></CENTER>\n";
	    &PrintFoot;
	}
    } else {
	&PrintHead('Passwort vergessen?', 1);
	print "<CENTER><B>Notiere die E-Mail Adresse unterhalb<BR>und klicke auf Submit. Es wird<BR>sofort per E-Mail verschickt<BR>und sollte in wenigen Minuten ankommen.<P>\n";
	print "<FORM ACTION=\"$ScriptURL?findpass\" METHOD=\"POST\">\n";
	print "E-Mail:<INPUT TYPE=\"TEXT\" NAME=\"find_email\" SIZE=30><INPUT TYPE=\"SUBMIT\" VALUE=\"Finde!\"></FORM><BR><BR><BR><BR></B></CENTER>\n";
	&PrintFoot;
    }
}